use crate::parser;
use rayon::prelude::*;
use std::thread::{spawn, JoinHandle};
use std::sync::mpsc::{sync_channel, Receiver};

// This is not needed atm 
//use serde::ser::{Serialize, SerializeStruct, Serializer};
//impl Serialize for parser::QryData {
//    fn serialize<S>(&self, serializer: S) -> Result<S::Ok, S::Error>
//    where
//        S: Serializer,
//    {
//        let mut state = serializer.serialize_struct("parser::QryData", 9)?;
//        state.serialize_field("time", &self.time)?;
//        state.serialize_field("ether_header", &self.ether_header)?;
//        state.serialize_field("ipv4_header", &self.ipv4_header)?;
//        state.serialize_field("ipv6_header", &self.ipv6_header)?;
//        state.serialize_field("tcp_header", &self.tcp_header)?;
//        state.serialize_field("udp_header", &self.udp_header)?;
//        state.serialize_field("arp_header", &self.arp_header)?;
//        state.serialize_field("data", &self.data)?;
//        state.serialize_field("reg_res", &self.reg_res)?;
//        state.end()
//    }
//}

#[allow(dead_code)]
pub fn serialize_packets(v: Vec<parser::QryData>) -> Vec<serde_json::Value> {
    /* rayon parallelized */
    // TODO: Benchmark. As far as I've tested, using rayon reaps no benefit nor does it run any slower. I leave it in for now.
    let packets_serialized = v
        .par_iter()
        .map(|x| serde_json::to_value(x).unwrap())
        .collect();
    //  let packets_serialized: Vec<serde_json::Value> = v.par_iter().map(|x| json!(x)).collect();
    packets_serialized
}

// This is way faster than serialize_packets() but I can not figure out how to properly select parts from the resulting json structure as an sql query
#[allow(dead_code)]
pub fn serialize_packets_as_string(v: Vec<parser::QryData>) -> Vec<serde_json::Value> {
    let mut packets_serialized: Vec<serde_json::Value> = Vec::with_capacity(v.len() * 2);
    for packet in v.iter() {
        packets_serialized.push(serde_json::Value::String(
            serde_json::to_string(&packet).unwrap(),
        ));
    }

    packets_serialized
}

#[allow(dead_code)]
pub fn mpsc_serialize(packet: Receiver<parser::QryData>) -> (Receiver<serde_json::Value>, JoinHandle<()>) {
    let (sender, receiver) = sync_channel(100);
    let handle = spawn( move || {
        for p in packet{
            let serialized = serde_json::to_value(p).unwrap();
            if sender.send(serialized).is_err(){
            return;
            }
        }
    });
    (receiver, handle)
}

